//+------------------------------------------------------------------+
//|                                            #_i_SpecktrAnalis.mq4 |
//|                                          Copyright  2006, klot. |
//|                                                     klot@mail.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, klot."
#property link      "klot@mail.ru"



#import "#_lib_FFT.ex4"
void realfastfouriertransform(double& a[], int tnn, bool inversefft);
#import

#property indicator_separate_window
#property indicator_buffers 8
#property indicator_color1 Magenta
#property indicator_color2 Gold
#property indicator_color3 Silver
#property indicator_color4 Aqua
#property indicator_color5 Magenta
#property indicator_color6 White
#property indicator_color7 Red
#property indicator_color8 Blue


#property indicator_level1 0.0
#property indicator_level2 0.0025
#property indicator_level3 -0.0025
#property indicator_level4 0.005
#property indicator_level5 -0.005
#property indicator_level6 0.0075
#property indicator_level7 -0.0075

extern bool EUR=true;
//extern string     Symbol1Long          = "EURUSD";//buy
extern string     Symbol2Long          = "EURAUD";//buy
extern string     Symbol3Long          = "EURCAD";//buy
extern string     Symbol4Long          = "EURGBP";//buy
extern string     Symbol5Long          = "EURJPY";//buy
extern string     Symbol6Long          = "EURCHF";//buy
extern string     Symbol7Long          = "EURNZD";//buy

//extern string     Symbol8Long          = "EURUSD";//
extern string     Symbol9Long          = "USDCHF";//1
extern string     Symbol10Long          = "AUDUSD";//
extern string     Symbol11Long          = "USDCAD";//1
extern string     Symbol12Long          = "GBPUSD";//
extern string     Symbol13Long          = "USDJPY";//1
extern string     Symbol14Long          = "NZDUSD";//
//---- buffers
double Buffer1[];
double Buffer2[];
double Buffer3[];
double Buffer4[];
double Buffer5[];
double Buffer6[];
double Buffer7[];
double Buffer8[];

//---
extern int n=10; //  
extern int Fmin=2;//2; //    .
extern int Fmax=128; //    .
extern int pearson_per=5;
//extern string sym="GBPUSD";
//extern string sym="EURUSD";
double aa0[];
double aa0_1[];
double aa0_2[];
double aa0_3[];
double aa0_4[];
double aa0_5[];
double aa0_6[];
double aa0_7[];

double aa0_8[];
double aa0_9[];
double aa0_10[];
double aa0_11[];
double aa0_12[];
double aa0_13[];
double aa0_14[];


double aa1[];
double aa2[];
double aa3[];
double aa4[];
double aa5[];
double aa6[];
double aa7[];
double aa8[];
double aa9[];
double aa10[];
double aa11[];
double aa12[];
double aa13[];
double aa14[];
int N;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
    if(StringFind(Symbol(),"m",0)>0)
   {
    //Symbol1Long = Symbol1Long+"m";
    Symbol2Long = Symbol2Long+"m";
    Symbol3Long = Symbol3Long+"m";
    Symbol4Long = Symbol4Long+"m";    
    Symbol5Long = Symbol5Long+"m";
    Symbol6Long = Symbol6Long+"m";
    Symbol7Long = Symbol7Long+"m";

    //Symbol8Long = Symbol8Long+"m";
    Symbol9Long = Symbol9Long+"m";
    Symbol10Long = Symbol10Long+"m";
    Symbol11Long = Symbol11Long+"m";    
    Symbol12Long = Symbol12Long+"m";
    Symbol13Long = Symbol13Long+"m";
    Symbol14Long = Symbol14Long+"m";


   }      
//---- indicators
SetIndexStyle(0,DRAW_HISTOGRAM,0,2);
SetIndexBuffer(0,Buffer1);
SetIndexStyle(1,DRAW_LINE);
SetIndexBuffer(1,Buffer2);
SetIndexStyle(2,DRAW_LINE);
SetIndexBuffer(2,Buffer3);
SetIndexStyle(3,DRAW_LINE);
SetIndexBuffer(3,Buffer4);
SetIndexStyle(4,DRAW_LINE);
SetIndexBuffer(4,Buffer5);
SetIndexStyle(5,DRAW_LINE);
SetIndexBuffer(5,Buffer6);
SetIndexStyle(6,DRAW_LINE);
SetIndexBuffer(6,Buffer7);
SetIndexStyle(7,DRAW_LINE);
SetIndexBuffer(7,Buffer8);



//---
   N=MathPow(2,n);
   ArrayResize(aa0,N);
   ArrayResize(aa0_1,N);
   ArrayResize(aa0_2,N);
   ArrayResize(aa0_3,N);
   ArrayResize(aa0_4,N);
   ArrayResize(aa0_5,N);
   ArrayResize(aa0_6,N);
   ArrayResize(aa0_7,N);

   ArrayResize(aa0_8,N);
   ArrayResize(aa0_9,N);
   ArrayResize(aa0_10,N);
   ArrayResize(aa0_11,N);
   ArrayResize(aa0_12,N);
   ArrayResize(aa0_13,N);
   ArrayResize(aa0_14,N);

   ArrayResize(aa1,N);
   ArrayResize(aa2,N);
   ArrayResize(aa3,N);
   ArrayResize(aa4,N);
   ArrayResize(aa5,N);
   ArrayResize(aa6,N);
   ArrayResize(aa7,N);
   ArrayResize(aa8,N);
   ArrayResize(aa9,N);
   ArrayResize(aa10,N);
   ArrayResize(aa11,N);
   ArrayResize(aa12,N);
   ArrayResize(aa13,N);                                    
   ArrayResize(aa14,N);                                    

if( Fmax>=N ) Fmax=N;
if( Fmin<=2 ) Fmin=2;

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {

   if( Bars<N) return(0);
   RefreshRates();
   //---
   for(int i=N-1; i>=0; i--) 
   { 
     //aa1[i]=iClose(Symbol1Long,0,i); 
     aa2[i]=iClose(Symbol2Long,0,i); 
     aa3[i]=iClose(Symbol3Long,0,i); 
     aa4[i]=iClose(Symbol4Long,0,i); 
     aa5[i]=iClose(Symbol5Long,0,i); 
     aa6[i]=iClose(Symbol6Long,0,i); 
     aa7[i]=iClose(Symbol7Long,0,i); 

     //aa8[i]=iClose(Symbol8Long,0,i); 
     aa9[i]=1/iClose(Symbol9Long,0,i); 
     aa10[i]=iClose(Symbol10Long,0,i); 
     aa11[i]=1/iClose(Symbol11Long,0,i); 
     aa12[i]=iClose(Symbol12Long,0,i); 
     aa13[i]=1/iClose(Symbol13Long,0,i); 
     aa14[i]=iClose(Symbol14Long,0,i); 

   }
   //---
   
   //InSigNormalize(aa1);
   InSigNormalize(aa2);
   InSigNormalize(aa3);
   InSigNormalize(aa4);
   InSigNormalize(aa5);
   InSigNormalize(aa6);
   InSigNormalize(aa7);
   //InSigNormalize(aa8);
   InSigNormalize(aa9);
   InSigNormalize(aa10);
   InSigNormalize(aa11);
   InSigNormalize(aa12);
   InSigNormalize(aa13);
   InSigNormalize(aa14);
   
   
   //realfastfouriertransform(aa1, N, false);
   realfastfouriertransform(aa2, N, false);
   realfastfouriertransform(aa3, N, false);
   realfastfouriertransform(aa4, N, false);
   realfastfouriertransform(aa5, N, false);
   realfastfouriertransform(aa6, N, false);
   realfastfouriertransform(aa7, N, false);
   //realfastfouriertransform(aa8, N, false);
   realfastfouriertransform(aa9, N, false);
   realfastfouriertransform(aa10, N, false);
   realfastfouriertransform(aa11, N, false);
   realfastfouriertransform(aa12, N, false);
   realfastfouriertransform(aa13, N, false);
   realfastfouriertransform(aa14, N, false);   
   //---
   N=ArraySize(aa2);
   //Comment("n= ",N);
   //---
   for( i=0; i<=N-1; i++) 
   { 
      if( i<Fmin || i>Fmax) 
      { 
        //aa1[i]=0.0; 
        aa2[i]=0.0; 
        aa3[i]=0.0; 
        aa4[i]=0.0; 
        aa5[i]=0.0; 
        aa6[i]=0.0; 
        aa7[i]=0.0; 
        //aa8[i]=0.0; 
        aa9[i]=0.0; 
        aa10[i]=0.0; 
        aa11[i]=0.0; 
        aa12[i]=0.0; 
        aa13[i]=0.0;                                                                                                 
        aa14[i]=0.0;                                                                                                         
      }
      aa0[i]=/*aa1[i]+*/aa2[i]+aa3[i]+aa4[i]+aa5[i]+aa6[i]+aa7[i]/*+aa8[i]*/+aa9[i]+aa10[i]+aa11[i]+aa12[i]+aa13[i]+aa13[i]+aa14[i];
      //aa0_1[i]=aa1[i];
      aa0_2[i]=aa2[i];
      aa0_3[i]=aa3[i];
      aa0_4[i]=aa4[i];
      aa0_5[i]=aa5[i];
      aa0_6[i]=aa6[i];
      aa0_7[i]=aa7[i];      

      //aa0_8[i]=aa8[i];
      aa0_9[i]=aa9[i];
      aa0_10[i]=aa10[i];
      aa0_11[i]=aa11[i];
      aa0_12[i]=aa12[i];
      aa0_13[i]=aa13[i];
      aa0_14[i]=aa14[i];      

      
   }
   //---
   //InSigNormalize(aa0);
   //InSigNormalize(aa0_buy);
   //InSigNormalize(aa0_sell);
   
   realfastfouriertransform(aa0, N, true);
   //realfastfouriertransform(aa0_1, N, true);
   realfastfouriertransform(aa0_2, N, true);
   realfastfouriertransform(aa0_3, N, true);
   realfastfouriertransform(aa0_4, N, true);
   realfastfouriertransform(aa0_5, N, true);
   realfastfouriertransform(aa0_6, N, true);
   realfastfouriertransform(aa0_7, N, true);

   //realfastfouriertransform(aa0_8, N, true);
   realfastfouriertransform(aa0_9, N, true);
   realfastfouriertransform(aa0_10, N, true);
   realfastfouriertransform(aa0_11, N, true);
   realfastfouriertransform(aa0_12, N, true);
   realfastfouriertransform(aa0_13, N, true);
   realfastfouriertransform(aa0_14, N, true);
   
   //---
   SetIndexDrawBegin(0,Bars-N);
   SetIndexDrawBegin(1,Bars-N);
   SetIndexDrawBegin(2,Bars-N);
   SetIndexDrawBegin(3,Bars-N);
   SetIndexDrawBegin(4,Bars-N);
   SetIndexDrawBegin(5,Bars-N);
   SetIndexDrawBegin(6,Bars-N);
   SetIndexDrawBegin(7,Bars-N);

   //---
   //double x1[20];
   //double y1[20];
   for( i=0; i<=N-1; i++)
   {
      Buffer1[i]=aa0[i];
      if(EUR==true)
      {
        //Buffer2[i]=aa0_1[i];
        Buffer3[i]=aa0_2[i];
        Buffer4[i]=aa0_3[i];
        Buffer5[i]=aa0_4[i];
        Buffer6[i]=aa0_5[i];
        Buffer7[i]=aa0_6[i];
        Buffer8[i]=aa0_7[i];      
      }
      else
      {
        //Buffer2[i]=aa0_8[i];
        Buffer3[i]=aa0_9[i];
        Buffer4[i]=aa0_10[i];
        Buffer5[i]=aa0_11[i];
        Buffer6[i]=aa0_12[i];
        Buffer7[i]=aa0_13[i];
        Buffer8[i]=aa0_14[i];      
      }
        

      /*
      for (int j=0;j<pearson_per;j++)
      {
        x1[j]= Buffer2[i+j];
        y1[j]= Buffer3[i+j];
      }  
      Buffer4[i]=pearson( x1,y1)/10;
      //Buffer4[i]=CorrelationIND(Buffer2,Buffer3,20,i)/100;
      */
   }
   //----
   return(0);
  }
//-------------------------------------------------------------------+
//--------------------------------------------------------------------+
void InSigNormalize(double& aa[])
{
   double sum_sqrt;
   int element_count=ArraySize(aa);
   sum_sqrt=0;
   for( int i=0; i<=element_count-1; i++)
   {
      sum_sqrt+=MathPow(aa[i],2);
   }
   sum_sqrt=MathSqrt(sum_sqrt);
   
   if (sum_sqrt!=0)
   {
      for( i=0; i<=element_count-1; i++)
      {
         aa[i]=aa[i]/sum_sqrt;
      }
   }
   return;
}
//---------------------------------------------------------------------+
//---------------------------------------------------------------------+
//int cPeriod=20
double CorrelationIND(double Symbol1[],double Symbol2[],int cPeriod,int CorrelationShift=0){
   double Correlation[],DiffBuffer1[],DiffBuffer2[],PowDiff1[],PowDiff2[];
   ArrayResize(Correlation,cPeriod*2);ArrayResize(DiffBuffer1,cPeriod*2);
   ArrayResize(DiffBuffer2,cPeriod*2);ArrayResize(PowDiff1,cPeriod*2);ArrayResize(PowDiff2,cPeriod*2);
   for( int shift=cPeriod+1; shift>=0; shift--){
      DiffBuffer1[shift]=Symbol1[shift];//iClose(Symbol1,0,shift)-iMA(Symbol1,0,cPeriod,0,MODE_SMA,PRICE_CLOSE,shift);
      DiffBuffer2[shift]=Symbol2[shift];//iClose(Symbol2,0,shift)-iMA(Symbol2,0,cPeriod,0,MODE_SMA,PRICE_CLOSE,shift);
      PowDiff1[shift]=MathPow(DiffBuffer1[shift],2);
      PowDiff2[shift]=MathPow(DiffBuffer2[shift],2);
      double u=0,l=0,s=0;
      for( int i = cPeriod-1 ;i >= 0 ;i--){
         u += DiffBuffer1[shift+i]*DiffBuffer2[shift+i];
         l += PowDiff1[shift+i];
         s += PowDiff2[shift+i];
      }
      if(l*s >0)Correlation[shift]=u/MathSqrt(l*s);
   }   
   return(Correlation[CorrelationShift]);
   return(-1); 
}

double pearson( double x[], double y[])
{
  int i,j;
  double sxy,sx,sx2,sy,sy2,a,b,c,r;
  int n1 = ArraySize(x);
  for(i=0; i<n1; i++)
  {
    sxy+=x[i]*y[i];
    sx+=x[i];
    sx2+=x[i]*x[i];
    sy+=y[i];
    sy2+=y[i]*y[i];   
  }
  a=sxy-sx*sy/n1;
  b=sx2-sx*sx/n1;
  c=sy2-sy*sy/n1;
  r=a/MathSqrt(b*c);
  return(r);
}